<template>
  <div class="form-container u-mb-30">
    <FormValidation v-if="errors.length > 0" :errors="errors" />
    <form>
      <div class="field required">
        <label class="label">Firstname</label>
        <div class="control">
          <input
            class="input"
            type="text"
            placeholder="e.g. John"
            v-model="user.firstName"
          />
        </div>
      </div>
      <div class="field required">
        <label class="label">Lastname</label>
        <div class="control">
          <input
            class="input"
            type="text"
            placeholder="e.g. Doe"
            v-model="user.lastName"
          />
        </div>
      </div>
      <div class="field required">
        <label class="label">Email</label>
        <div class="control">
          <input
            class="input"
            type="email"
            placeholder="e.g. johndoe@email.ext"
            v-model="user.email"
          />
        </div>
      </div>
      <p class="help has-text-grey-light u-mb-30">
        * Fields marked with an asterisk (*) are required
      </p>
      <button class="button is-primary" @click.prevent="onSubmit">
        Update
      </button>
      <button
        class="button is-danger is-outlined icon is-pulled-right"
        @click.prevent="DELETE_USER(user._id)"
      >
        Delete
        <span class="icon-r icon-delete"></span>
      </button>
    </form>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import Api from "@/api";
import FormValidation from "@/components/FormValidation.vue";

export default {
  name: "EditUserForm",
  data() {
    return {
      user: {
        _id: this.$route.params.id
      },
      errors: []
    };
  },
  methods: {
    ...mapActions(["UPDATE_USER", "DELETE_USER"]),
    getUser() {
      Api()
        .get(`/users/${this.user._id}`)
        .then(response => {
          this.user = response.data.data;
        })
        .catch(() => {
          this.$router.push({ path: "/error" });
        });
    },
    onSubmit() {
      this.errors.length = 0;
      if (this.user.firstName && this.user.lastName && this.user.email) {
        this.UPDATE_USER(this.user);
      } else {
        if (!this.user.firstName) this.errors.push("Firstname is required.");
        if (!this.user.lastName) this.errors.push("Lastname is required.");
        if (!this.user.email) this.errors.push("Email is required.");
      }
    }
  },
  components: {
    FormValidation
  },
  created() {
    this.getUser();
  }
};
</script>
